两次入坑逆向拓扑序(POJ 3687 Labeling Balls and HDU 4857 逃生)

2024-01-25 00:48

本文主要是介绍两次入坑逆向拓扑序(POJ 3687 Labeling Balls and HDU 4857 逃生),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

第一次跳坑

POJ 3687 Labeling Balls

Description

Windy has N balls of distinct weights from 1 unit to N units. Now he tries to label them with 1 to N in such a way that:

No two balls share the same label.
The labeling satisfies several constrains like “The ball labeled with a is lighter than the one labeled with b”.
Can you help windy to find a solution?

Input

The first line of input is the number of test case. The first line of each test case contains two integers, N (1 ≤ N ≤ 200) and M (0 ≤ M ≤ 40,000). The next M line each contain two integers a and b indicating the ball labeled with a must be lighter than the one labeled with b. (1 ≤ a, b ≤ N) There is a blank line before each test case.

Output

For each test case output on a single line the balls’ weights from label 1 to label N. If several solutions exist, you should output the one with the smallest weight for label 1, then with the smallest weight for label 2, then with the smallest weight for label 3 and so on… If no solution exists, output -1 instead.

Sample Input

5

4 0

4 1
1 1

4 2
1 2
2 1

4 1
2 1

4 1
3 2
Sample Output

1 2 3 4
-1
-1
2 1 3 4
1 3 2 4

问题概述
有 N 个重量 1~N 不等的球, 将其1~N 编号。题目给出 M 个条件 a,b, 表示 a 号球比 b 号球轻,然后输出小球重量由小到大的编码排序。开始我的理解是这样的(;′⌒`)然后复杂的蹦坑模式就开始了。
1、审题很不认真的一点,输出的不是小球的编号,而是小球的重量,是按照小球从编号 1~N 的顺序输出小球重量。
2、这个题目用入度数组加正向拓扑是通不过的
you should output the one with the smallest weight for label 1, then with the smallest weight for label 2, then with the smallest weight for label 3 and so on…
这个要求是让编号小的尽量排在前面,如果正向拓扑,会存在编号较小的点被更大的点挡住的问题;所以通过逆向拓扑加上优先队列大顶堆维护的方法,每次都选出来编号较大的点,编号小的点自然就在后面啦,再按照要求选择顺序输出结果。

测试数据:
方法选择:测试数据(5 4 1 4 4 2 2 3 3 5) 正向拓扑:1->4->2,5->3->2可得结果 1 4 5 3 2,显然这是不对的,因为1 4 与 5 3 之间没有相互约束,按照编号小应在前的原则,5 3 应位于 4 之前。则答案为最后逆向拓扑序的结果 1 5 3 4 2;
获得最终结果:测试数据(5 4 1 4 4 2 5 3 3 2) 逆向拓扑序后得 out[]={ 2(i=0) 4(i=1) 3(i=2) 5(i=3) 1(i=4) } (按照重量由大到小),所以编号为2的小球是重量最大的小球,重量即为 (m-i),即为 realout[2];同理便可得到最终的数组 realout[]。

代码实现

#include <iostream>
#include<cstdio>
#include<vector>
#include<cstring>
#include<queue>
using namespace std;
vector<int>a[206];
int in[206];            //入度数组
int m,n,countt;
int out[206];              //逆向拓扑序的结果(按照重量由大到小)
int realout[206];        //小球按照编号 1~N 分别对应的重量
int toposort()
{countt=0;priority_queue<int>qu;for(int i=1; i<=m; i++)if(!in[i])qu.push(i);while(!qu.empty()){int temp=qu.top();qu.pop();out[countt++]=temp;for(int i=0; i<a[temp].size(); i++){int z=a[temp][i];if(--in[z]==0)qu.push(z);}}if(countt>=m) return true;elsereturn false;
}
int main()
{int T,x,y;scanf("%d",&T);while(T--){scanf("%d %d",&m,&n);for(int i=0; i<=m; i++)a[i].clear();memset(in,0,sizeof(in));for(int i=0; i<n; i++){scanf("%d %d",&x,&y);a[y].push_back(x);in[x]++;}if(!toposort())printf("-1\n");else{for(int i=0; i<m; i++)realout[out[i]]=m-i;       //获取重量for(int i=1; i<m; i++)printf("%d ",realout[i]);printf("%d\n",realout[m]);}}return 0;
}

第二次跳坑

HDU 4857 逃生

Problem Description
糟糕的事情发生啦,现在大家都忙着逃命。但是逃命的通道很窄,大家只能排成一行。

现在有n个人,从1标号到n。同时有一些奇怪的约束条件,每个都形如:a必须在b之前。
同时,社会是不平等的,这些人有的穷有的富。1号最富,2号第二富,以此类推。有钱人就贿赂负责人,所以他们有一些好处。

负责人现在可以安排大家排队的顺序,由于收了好处,所以他要让1号尽量靠前,如果此时还有多种情况,就再让2号尽量靠前,如果还有多种情况,就让3号尽量靠前,以此类推。

那么你就要安排大家的顺序。我们保证一定有解。

Input
第一行一个整数T(1 <= T <= 5),表示测试数据的个数。
然后对于每个测试数据,第一行有两个整数n(1 <= n <= 30000)和m(1 <= m <= 100000),分别表示人数和约束的个数。

然后m行,每行两个整数a和b,表示有一个约束a号必须在b号之前。a和b必然不同。

Output
对每个测试数据,输出一行排队的顺序,用空格隔开。

Sample Input
1
5 10
3 5
1 4
2 5
1 2
3 4
1 4
2 3
1 5
3 5
1 2

Sample Output
1 2 3 4 5

问题概述
和上一个题目相似,再次跳坑的感觉很不好啊,开始怀疑自己的理解能力了(;′⌒`)正向拓扑提交了好多次,爬起来!依旧是编号小的尽量往前放,逆向拓扑排序,倒序输出!

代码实现

#include <iostream>
#include<cstdio>
#include<vector>
#include<cstring>
#include<queue>
using namespace std;
#define maxn 30006
vector<int>a[maxn];
int in[maxn],m,n,countt;
int out[maxn],realout[maxn];
int toposort()
{countt=0;priority_queue<int>qu;for(int i=1; i<=m; i++)if(!in[i])qu.push(i);while(!qu.empty()){int temp=qu.top();qu.pop();out[countt++]=temp;for(int i=0; i<a[temp].size(); i++){int z=a[temp][i];if(--in[z]==0)qu.push(z);}}
}
int main()
{int T,x,y;scanf("%d",&T);while(T--){scanf("%d %d",&m,&n);for(int i=0; i<=m; i++)a[i].clear();memset(in,0,sizeof(in));for(int i=0; i<n; i++){scanf("%d %d",&x,&y);a[y].push_back(x);in[x]++;}toposort();for(int i=m-1;i>0;i--)printf("%d ",out[i]);printf("%d\n",out[0]);}return 0;
}

这篇关于两次入坑逆向拓扑序(POJ 3687 Labeling Balls and HDU 4857 逃生)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/641585

相关文章

hdu1254(嵌套bfs,两次bfs)

/*第一次做这种题感觉很有压力,思路还是有点混乱,总是wa,改了好多次才ac的思路:把箱子的移动当做第一层bfs,队列节点要用到当前箱子坐标(x,y),走的次数step,当前人的weizhi(man_x,man_y),要判断人能否将箱子推到某点时要嵌套第二层bfs(人的移动);代码如下:

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D